void goMonitor()
{
  //This will count the number of PIR triggers per hour
  //Each hour and write them to SD card.
  //If between hours of say 0800 to 2000 There are <= x movements per hour then send a notification
  //Serial.println (currentTime);
  //eventCounter = 4; //Test only
  //totalDailyEvents = 20; //Test only


  if (digitalRead(PIR) == HIGH)
  {
    if (oldPirIn == false )
    {
      oldPirIn = true;
      Serial.println ("PIR triggered");
      if (movementLedOn)
      {
        digitalWrite(LED, LOW);
        delay (200);
        digitalWrite(LED, HIGH);
      }
      eventCounter ++;//increment the event counters
      totalDailyEvents ++;
      Serial.println ("eventCounter is: " + String (eventCounter));
      oldPirIn = true;  // reset oldPirIn if pirIn = false
      if (connected2Blynk)
      {
        //Blynk.setProperty(V0, "label", "Terminal. Send H for Help Index.   Event Counter = " + String (eventCounter));
        Blynk.virtualWrite(V2, eventCounter);
        Blynk.virtualWrite(V3, totalDailyEvents);
      }
      // pirIn is true when PIR sensor output is high
    }
  }
  else
  {
    if (oldPirIn == true)
    {
      oldPirIn = false;
      Serial.println ("PIR reset.");
      if (movementLedOn)
      {
        digitalWrite(LED, LOW);
        delay (25);
        digitalWrite(LED, HIGH);
      }
    }
  }
    //*********END OF HOUR ********************
  if (endOfHour) // End of Hour: Minutes roll over to zero
  {
    //Save to SD card
    writeLogFile(String (eventCounter)); // Write Hourly Events
    endOfHour = false;  // do it once

    //End of Day
    //if (currentDate != oldDate and currentHour == 24) // then Midnight last hour gets recorded with Yesterday's date and Hour = 24 in writeDailyEven
    if (currentHour == 0) // then Midnight last hour gets recorded with Yesterday's date and Hour = 24 in writeDailyEvents
    {
      writeDailyEvents();
      totalDailyEvents = 0; // Reset Counter
      if (connected2Blynk)
      {
        //Blynk.setProperty(V0, "label", "Terminal. Send H for Help Index.   Event Counter = " + String (eventCounter));
        Blynk.virtualWrite(V3, totalDailyEvents);
      }
    }
    //Check if Hourly Notification is to be sents
    bool black = false;
    if (currentHour == 0 and blackout[24] == 1)
    {
      black = true;
    }
    if (currentHour != 0)
    {
      if (blackout[currentHour] == 1)// blackout[] index 1 to 24
      {
        black = true;
      }
    }

    //Serial.println ("Current Hour: " + String (currentHour));
    //Serial.println ("Blackout[24]: " + String (blackout[24]));
    //Serial.println ("Blackout[currentHour]: " + String (blackout[currentHour]));
    //Serial.println ("Notifications: " + String (notificationOn));
    //Serial.println ("Event Counter: " + String (eventCounter));
    //Serial.println ("Events Threshold: " + String (eventsThreshold));
    //Serial.println ("Monitor Start Hour: " + String (monitorStartHour));
    //Serial.println ("Monitor End Hour: " + String (monitorEndHour));
    //Serial.println ("Suspend Notification: " + String (suspendNotification));
    //Serial.println ("Black is: " + String (black));

    if (notificationOn and eventCounter <= eventsThreshold and currentHour > monitorStartHour and currentHour <= monitorEndHour and suspendNotification == 0 and black == false  )// Notify
    {
      Serial.println ("Notifying with Blynk Message");
      if (!Blynk.connected())
      {
        connectBlynk();
        delay (500);
        Blynk.notify(message1 + char(13) + char(10) + message2 + char(13) + char(10) + currentDate + " " + currentTime + char(13) + char(10) + "Hours Events: " + String (eventCounter) + "   Threshold: " + String (eventsThreshold));
      }
      else
      {
        Blynk.notify(message1 + char(13) + char(10) +  message2 + char(13) + char(10) + currentDate + " " + currentTime + char(13) + char(10) + "Hours Events:" + String (eventCounter) + "   Threshold: " + String (eventsThreshold));
      }
    }
    if (reportHour == currentHour)
    {
      Serial.println("Reporting Hour");
      if (!Blynk.connected())
      {
        connectBlynk();
        
      }
      delay (1000);
      Blynk.notify(message1 +  " Is On Line. Reporting Home.");
    }
    if (suspendNotification > 0)
    {
      suspendNotification --; //
    }
    eventCounter = 0;//reset the eventCounter
    if (connected2Blynk)
    {
      // Blynk.setProperty(V0, "label", "Terminal. Send H for Help Index.   Event Counter = " + String (eventCounter));
      Blynk.virtualWrite(V2, eventCounter);
    }
  }
}

